"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var bluebird_1 = __importDefault(require("bluebird"));
var EmulatorCommand = (function () {
    function EmulatorCommand(connection, parser) {
        this.connection = connection;
        this.parser = parser;
    }
    EmulatorCommand.prototype.setTimeout = function (ms) {
        this.timeout = ms;
        return this;
    };
    EmulatorCommand.prototype.execute = function () {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var handler;
        return new bluebird_1.default(function (resolve, reject) {
            if (_this.timeout) {
                _this.connection.setTimeout(_this.timeout, function () {
                    reject(new Error("Command timeout"));
                });
            }
            var response = "";
            _this.connection.on("data", (handler = function (data) {
                var dataStr = data.toString();
                var err;
                if (/OK/.test(dataStr.slice(dataStr.length - 4, dataStr.length - 2))) {
                    response = response.concat(dataStr);
                    return resolve(response);
                }
                if ((err = _this.parser.checkError(dataStr))) {
                    return reject(err);
                }
                {
                    return (response = response.concat(dataStr));
                }
            }));
            _this.connection.write("".concat(args.join(" ")));
        }).finally(function () {
            _this.connection.removeListener("data", handler);
            _this.connection.end();
        });
    };
    return EmulatorCommand;
}());
exports.default = EmulatorCommand;
