/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
import EventEmitter from "events";
import { SocketConnectOpts } from "net";
import Parser from "./parser";
export default class Connection extends EventEmitter {
    private socket;
    private parser;
    constructor(token: string, parser: Parser, options: SocketConnectOpts);
    setTimeout(ms: number, cb: VoidFunction): void;
    write(data: string, cb?: (err?: Error) => void): void;
    private authorize;
    on(event: "timeout", listener: VoidFunction): this;
    on(event: "data", listener: (data: Buffer) => void): this;
    on(event: "auth", listener: VoidFunction): this;
    on(event: "end", listener: VoidFunction): this;
    on(event: "error", listener: (err: Error) => void): this;
    end(): void;
}
