"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = __importDefault(require("events"));
var net_1 = require("net");
var Connection = (function (_super) {
    __extends(Connection, _super);
    function Connection(token, parser, options) {
        var _this = _super.call(this) || this;
        _this.socket = new net_1.Socket();
        _this.parser = parser;
        _this.authorize(token, options);
        _this.once("auth", function () {
            _this.socket.on("data", function (data) {
                _this.emit("data", data);
            });
        });
        _this.socket.on("error", function (err) {
            _this.emit("error", err);
        });
        return _this;
    }
    Connection.prototype.setTimeout = function (ms, cb) {
        this.socket.setTimeout(ms, cb);
    };
    Connection.prototype.write = function (data, cb) {
        this.socket.write("".concat(data, "\r\n"), cb);
    };
    Connection.prototype.authorize = function (token, options) {
        var _this = this;
        var handler;
        this.socket.once("connect", function () {
            _this.write("auth ".concat(token));
        });
        this.socket.on("data", (handler = (function (data) {
            var dataStr = data.toString();
            var okRegExp = /type 'help'/;
            if (okRegExp.test(dataStr)) {
                _this.socket.removeListener("data", handler);
                _this.emit("auth");
            }
            else {
                var err = _this.parser.checkError(data);
                if (err) {
                    _this.socket.removeListener("data", handler);
                    _this.emit("error", err);
                }
            }
        }).bind(this)));
        this.socket.connect(options);
    };
    Connection.prototype.on = function (event, listener) {
        return _super.prototype.on.call(this, event, listener);
    };
    Connection.prototype.end = function () {
        var _this = this;
        this.socket.end(function () {
            _this.emit("end");
            _this.socket.removeAllListeners();
            _this.removeAllListeners();
        });
    };
    return Connection;
}(events_1.default));
exports.default = Connection;
