export { default as EmulatorClient } from "./client";
export { default as Parser } from "./parser";
export declare type SimpleType = string | boolean | number | null | undefined;
export declare function stringToType(value: string): SimpleType;
export declare type PowerStatus = "unknown" | "charging" | "discharging" | "not-charging" | "full";
export declare type PowerDisplay = {
    ac: "online" | "offline";
    status: string;
    present: boolean;
    health: string;
    capacity: number;
};
export declare type NetProtocol = "tcp" | "udp";
export declare type RedirObject = {
    protocol: NetProtocol;
    hostPort: number;
    guestPort: number;
};
export declare type EventType = "EV_SYN" | "EV_KEY" | "EV_REL" | "EV_ABS" | "EV_MSC" | "EV_SW" | "EV_LED" | "EV_SND" | "EV_REP" | "EV_FF" | "EV_PWR" | "EV_FF_STATUS" | "EV_MAX";
export declare type GsmListObject = {
    type: "outbound" | "inbound";
    phoneNr: string;
    status: "active" | "incoming" | "held" | "ringing" | "waiting";
};
export declare type GsmState = "unregistered" | "home" | "roaming" | "searching" | "denied" | "off" | "on";
export declare type SnapshotObject = {
    id?: number;
    tag: string;
    size: string;
    date: Date;
    vmClock: string;
};
export declare type ScreenRecordOptions = {
    width?: number;
    height?: number;
    bitRate?: number;
    timeLimit?: number;
    fsp?: number;
};
export declare const EmulatorPorts: number[];
